git-rebase--interactive.shon commit Merge branch 'mk/mingw-winansi-ttyname-termination-fix' into maint (8554ee1)
   1# This shell script fragment is sourced by git-rebase to implement
   2# its interactive mode.  "git rebase --interactive" makes it easy
   3# to fix up commits in the middle of a series and rearrange commits.
   4#
   5# Copyright (c) 2006 Johannes E. Schindelin
   6#
   7# The original idea comes from Eric W. Biederman, in
   8# http://article.gmane.org/gmane.comp.version-control.git/22407
   9#
  10# The file containing rebase commands, comments, and empty lines.
  11# This file is created by "git rebase -i" then edited by the user.  As
  12# the lines are processed, they are removed from the front of this
  13# file and written to the tail of $done.
  14todo="$state_dir"/git-rebase-todo
  15
  16# The rebase command lines that have already been processed.  A line
  17# is moved here when it is first handled, before any associated user
  18# actions.
  19done="$state_dir"/done
  20
  21# The commit message that is planned to be used for any changes that
  22# need to be committed following a user interaction.
  23msg="$state_dir"/message
  24
  25# The file into which is accumulated the suggested commit message for
  26# squash/fixup commands.  When the first of a series of squash/fixups
  27# is seen, the file is created and the commit message from the
  28# previous commit and from the first squash/fixup commit are written
  29# to it.  The commit message for each subsequent squash/fixup commit
  30# is appended to the file as it is processed.
  31#
  32# The first line of the file is of the form
  33#     # This is a combination of $count commits.
  34# where $count is the number of commits whose messages have been
  35# written to the file so far (including the initial "pick" commit).
  36# Each time that a commit message is processed, this line is read and
  37# updated.  It is deleted just before the combined commit is made.
  38squash_msg="$state_dir"/message-squash
  39
  40# If the current series of squash/fixups has not yet included a squash
  41# command, then this file exists and holds the commit message of the
  42# original "pick" commit.  (If the series ends without a "squash"
  43# command, then this can be used as the commit message of the combined
  44# commit without opening the editor.)
  45fixup_msg="$state_dir"/message-fixup
  46
  47# $rewritten is the name of a directory containing files for each
  48# commit that is reachable by at least one merge base of $head and
  49# $upstream. They are not necessarily rewritten, but their children
  50# might be.  This ensures that commits on merged, but otherwise
  51# unrelated side branches are left alone. (Think "X" in the man page's
  52# example.)
  53rewritten="$state_dir"/rewritten
  54
  55dropped="$state_dir"/dropped
  56
  57end="$state_dir"/end
  58msgnum="$state_dir"/msgnum
  59
  60# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
  61# GIT_AUTHOR_DATE that will be used for the commit that is currently
  62# being rebased.
  63author_script="$state_dir"/author-script
  64
  65# When an "edit" rebase command is being processed, the SHA1 of the
  66# commit to be edited is recorded in this file.  When "git rebase
  67# --continue" is executed, if there are any staged changes then they
  68# will be amended to the HEAD commit, but only provided the HEAD
  69# commit is still the commit to be edited.  When any other rebase
  70# command is processed, this file is deleted.
  71amend="$state_dir"/amend
  72
  73# For the post-rewrite hook, we make a list of rewritten commits and
  74# their new sha1s.  The rewritten-pending list keeps the sha1s of
  75# commits that have been processed, but not committed yet,
  76# e.g. because they are waiting for a 'squash' command.
  77rewritten_list="$state_dir"/rewritten-list
  78rewritten_pending="$state_dir"/rewritten-pending
  79
  80# Work around Git for Windows' Bash whose "read" does not strip CRLF
  81# and leaves CR at the end instead.
  82cr=$(printf "\015")
  83
  84strategy_args=${strategy:+--strategy=$strategy}
  85test -n "$strategy_opts" &&
  86eval '
  87        for strategy_opt in '"$strategy_opts"'
  88        do
  89                strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
  90        done
  91'
  92
  93GIT_CHERRY_PICK_HELP="$resolvemsg"
  94export GIT_CHERRY_PICK_HELP
  95
  96comment_char=$(git config --get core.commentchar 2>/dev/null)
  97case "$comment_char" in
  98'' | auto)
  99        comment_char="#"
 100        ;;
 101?)
 102        ;;
 103*)
 104        comment_char=$(echo "$comment_char" | cut -c1)
 105        ;;
 106esac
 107
 108warn () {
 109        printf '%s\n' "$*" >&2
 110}
 111
 112# Output the commit message for the specified commit.
 113commit_message () {
 114        git cat-file commit "$1" | sed "1,/^$/d"
 115}
 116
 117orig_reflog_action="$GIT_REFLOG_ACTION"
 118
 119comment_for_reflog () {
 120        case "$orig_reflog_action" in
 121        ''|rebase*)
 122                GIT_REFLOG_ACTION="rebase -i ($1)"
 123                export GIT_REFLOG_ACTION
 124                ;;
 125        esac
 126}
 127
 128last_count=
 129mark_action_done () {
 130        sed -e 1q < "$todo" >> "$done"
 131        sed -e 1d < "$todo" >> "$todo".new
 132        mv -f "$todo".new "$todo"
 133        new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
 134        echo $new_count >"$msgnum"
 135        total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
 136        echo $total >"$end"
 137        if test "$last_count" != "$new_count"
 138        then
 139                last_count=$new_count
 140                eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
 141                test -z "$verbose" || echo
 142        fi
 143}
 144
 145# Put the last action marked done at the beginning of the todo list
 146# again. If there has not been an action marked done yet, leave the list of
 147# items on the todo list unchanged.
 148reschedule_last_action () {
 149        tail -n 1 "$done" | cat - "$todo" >"$todo".new
 150        sed -e \$d <"$done" >"$done".new
 151        mv -f "$todo".new "$todo"
 152        mv -f "$done".new "$done"
 153}
 154
 155append_todo_help () {
 156        gettext "
 157Commands:
 158 p, pick = use commit
 159 r, reword = use commit, but edit the commit message
 160 e, edit = use commit, but stop for amending
 161 s, squash = use commit, but meld into previous commit
 162 f, fixup = like \"squash\", but discard this commit's log message
 163 x, exec = run command (the rest of the line) using shell
 164 d, drop = remove commit
 165
 166These lines can be re-ordered; they are executed from top to bottom.
 167" | git stripspace --comment-lines >>"$todo"
 168
 169        if test $(get_missing_commit_check_level) = error
 170        then
 171                gettext "
 172Do not remove any line. Use 'drop' explicitly to remove a commit.
 173" | git stripspace --comment-lines >>"$todo"
 174        else
 175                gettext "
 176If you remove a line here THAT COMMIT WILL BE LOST.
 177" | git stripspace --comment-lines >>"$todo"
 178        fi
 179}
 180
 181make_patch () {
 182        sha1_and_parents="$(git rev-list --parents -1 "$1")"
 183        case "$sha1_and_parents" in
 184        ?*' '?*' '?*)
 185                git diff --cc $sha1_and_parents
 186                ;;
 187        ?*' '?*)
 188                git diff-tree -p "$1^!"
 189                ;;
 190        *)
 191                echo "Root commit"
 192                ;;
 193        esac > "$state_dir"/patch
 194        test -f "$msg" ||
 195                commit_message "$1" > "$msg"
 196        test -f "$author_script" ||
 197                get_author_ident_from_commit "$1" > "$author_script"
 198}
 199
 200die_with_patch () {
 201        echo "$1" > "$state_dir"/stopped-sha
 202        make_patch "$1"
 203        die "$2"
 204}
 205
 206exit_with_patch () {
 207        echo "$1" > "$state_dir"/stopped-sha
 208        make_patch $1
 209        git rev-parse --verify HEAD > "$amend"
 210        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 211        warn "$(eval_gettext "\
 212You can amend the commit now, with
 213
 214        git commit --amend \$gpg_sign_opt_quoted
 215
 216Once you are satisfied with your changes, run
 217
 218        git rebase --continue")"
 219        warn
 220        exit $2
 221}
 222
 223die_abort () {
 224        apply_autostash
 225        rm -rf "$state_dir"
 226        die "$1"
 227}
 228
 229has_action () {
 230        test -n "$(git stripspace --strip-comments <"$1")"
 231}
 232
 233is_empty_commit() {
 234        tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
 235                sha1=$1
 236                die "$(eval_gettext "\$sha1: not a commit that can be picked")"
 237        }
 238        ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
 239                ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 240        test "$tree" = "$ptree"
 241}
 242
 243is_merge_commit()
 244{
 245        git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
 246}
 247
 248# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
 249# GIT_AUTHOR_DATE exported from the current environment.
 250do_with_author () {
 251        (
 252                export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 253                "$@"
 254        )
 255}
 256
 257git_sequence_editor () {
 258        if test -z "$GIT_SEQUENCE_EDITOR"
 259        then
 260                GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
 261                if [ -z "$GIT_SEQUENCE_EDITOR" ]
 262                then
 263                        GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
 264                fi
 265        fi
 266
 267        eval "$GIT_SEQUENCE_EDITOR" '"$@"'
 268}
 269
 270pick_one () {
 271        ff=--ff
 272
 273        case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
 274        case "$force_rebase" in '') ;; ?*) ff= ;; esac
 275        output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
 276
 277        if is_empty_commit "$sha1"
 278        then
 279                empty_args="--allow-empty"
 280        fi
 281
 282        test -d "$rewritten" &&
 283                pick_one_preserving_merges "$@" && return
 284        output eval git cherry-pick \
 285                        ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 286                        "$strategy_args" $empty_args $ff "$@"
 287
 288        # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
 289        # previous task so this commit is not lost.
 290        ret=$?
 291        case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
 292        return $ret
 293}
 294
 295pick_one_preserving_merges () {
 296        fast_forward=t
 297        case "$1" in
 298        -n)
 299                fast_forward=f
 300                sha1=$2
 301                ;;
 302        *)
 303                sha1=$1
 304                ;;
 305        esac
 306        sha1=$(git rev-parse $sha1)
 307
 308        if test -f "$state_dir"/current-commit
 309        then
 310                if test "$fast_forward" = t
 311                then
 312                        while read current_commit
 313                        do
 314                                git rev-parse HEAD > "$rewritten"/$current_commit
 315                        done <"$state_dir"/current-commit
 316                        rm "$state_dir"/current-commit ||
 317                                die "$(gettext "Cannot write current commit's replacement sha1")"
 318                fi
 319        fi
 320
 321        echo $sha1 >> "$state_dir"/current-commit
 322
 323        # rewrite parents; if none were rewritten, we can fast-forward.
 324        new_parents=
 325        pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
 326        if test "$pend" = " "
 327        then
 328                pend=" root"
 329        fi
 330        while [ "$pend" != "" ]
 331        do
 332                p=$(expr "$pend" : ' \([^ ]*\)')
 333                pend="${pend# $p}"
 334
 335                if test -f "$rewritten"/$p
 336                then
 337                        new_p=$(cat "$rewritten"/$p)
 338
 339                        # If the todo reordered commits, and our parent is marked for
 340                        # rewriting, but hasn't been gotten to yet, assume the user meant to
 341                        # drop it on top of the current HEAD
 342                        if test -z "$new_p"
 343                        then
 344                                new_p=$(git rev-parse HEAD)
 345                        fi
 346
 347                        test $p != $new_p && fast_forward=f
 348                        case "$new_parents" in
 349                        *$new_p*)
 350                                ;; # do nothing; that parent is already there
 351                        *)
 352                                new_parents="$new_parents $new_p"
 353                                ;;
 354                        esac
 355                else
 356                        if test -f "$dropped"/$p
 357                        then
 358                                fast_forward=f
 359                                replacement="$(cat "$dropped"/$p)"
 360                                test -z "$replacement" && replacement=root
 361                                pend=" $replacement$pend"
 362                        else
 363                                new_parents="$new_parents $p"
 364                        fi
 365                fi
 366        done
 367        case $fast_forward in
 368        t)
 369                output warn "$(eval_gettext "Fast-forward to \$sha1")"
 370                output git reset --hard $sha1 ||
 371                        die "$(eval_gettext "Cannot fast-forward to \$sha1")"
 372                ;;
 373        f)
 374                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 375
 376                if [ "$1" != "-n" ]
 377                then
 378                        # detach HEAD to current parent
 379                        output git checkout $first_parent 2> /dev/null ||
 380                                die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
 381                fi
 382
 383                case "$new_parents" in
 384                ' '*' '*)
 385                        test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
 386
 387                        # redo merge
 388                        author_script_content=$(get_author_ident_from_commit $sha1)
 389                        eval "$author_script_content"
 390                        msg_content="$(commit_message $sha1)"
 391                        # No point in merging the first parent, that's HEAD
 392                        new_parents=${new_parents# $first_parent}
 393                        merge_args="--no-log --no-ff"
 394                        if ! do_with_author output eval \
 395                        'git merge ${gpg_sign_opt:+"$gpg_sign_opt"} \
 396                                $merge_args $strategy_args -m "$msg_content" $new_parents'
 397                        then
 398                                printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
 399                                die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
 400                        fi
 401                        echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
 402                        ;;
 403                *)
 404                        output eval git cherry-pick \
 405                                ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 406                                "$strategy_args" "$@" ||
 407                                die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
 408                        ;;
 409                esac
 410                ;;
 411        esac
 412}
 413
 414this_nth_commit_message () {
 415        n=$1
 416        eval_gettext "This is the commit message #\${n}:"
 417}
 418
 419skip_nth_commit_message () {
 420        n=$1
 421        eval_gettext "The commit message #\${n} will be skipped:"
 422}
 423
 424update_squash_messages () {
 425        if test -f "$squash_msg"; then
 426                mv "$squash_msg" "$squash_msg".bak || exit
 427                count=$(($(sed -n \
 428                        -e "1s/^$comment_char.*\([0-9][0-9]*\).*/\1/p" \
 429                        -e "q" < "$squash_msg".bak)+1))
 430                {
 431                        printf '%s\n' "$comment_char $(eval_ngettext \
 432                                "This is a combination of \$count commit." \
 433                                "This is a combination of \$count commits." \
 434                                $count)"
 435                        sed -e 1d -e '2,/^./{
 436                                /^$/d
 437                        }' <"$squash_msg".bak
 438                } >"$squash_msg"
 439        else
 440                commit_message HEAD > "$fixup_msg" || die "$(gettext "Cannot write \$fixup_msg")"
 441                count=2
 442                {
 443                        printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
 444                        printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
 445                        echo
 446                        cat "$fixup_msg"
 447                } >"$squash_msg"
 448        fi
 449        case $1 in
 450        squash)
 451                rm -f "$fixup_msg"
 452                echo
 453                printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
 454                echo
 455                commit_message $2
 456                ;;
 457        fixup)
 458                echo
 459                printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
 460                echo
 461                # Change the space after the comment character to TAB:
 462                commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
 463                ;;
 464        esac >>"$squash_msg"
 465}
 466
 467peek_next_command () {
 468        git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
 469}
 470
 471# A squash/fixup has failed.  Prepare the long version of the squash
 472# commit message, then die_with_patch.  This code path requires the
 473# user to edit the combined commit message for all commits that have
 474# been squashed/fixedup so far.  So also erase the old squash
 475# messages, effectively causing the combined commit to be used as the
 476# new basis for any further squash/fixups.  Args: sha1 rest
 477die_failed_squash() {
 478        sha1=$1
 479        rest=$2
 480        mv "$squash_msg" "$msg" || exit
 481        rm -f "$fixup_msg"
 482        cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
 483        warn
 484        warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
 485        die_with_patch $sha1 ""
 486}
 487
 488flush_rewritten_pending() {
 489        test -s "$rewritten_pending" || return
 490        newsha1="$(git rev-parse HEAD^0)"
 491        sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
 492        rm -f "$rewritten_pending"
 493}
 494
 495record_in_rewritten() {
 496        oldsha1="$(git rev-parse $1)"
 497        echo "$oldsha1" >> "$rewritten_pending"
 498
 499        case "$(peek_next_command)" in
 500        squash|s|fixup|f)
 501                ;;
 502        *)
 503                flush_rewritten_pending
 504                ;;
 505        esac
 506}
 507
 508do_pick () {
 509        sha1=$1
 510        rest=$2
 511        if test "$(git rev-parse HEAD)" = "$squash_onto"
 512        then
 513                # Set the correct commit message and author info on the
 514                # sentinel root before cherry-picking the original changes
 515                # without committing (-n).  Finally, update the sentinel again
 516                # to include these changes.  If the cherry-pick results in a
 517                # conflict, this means our behaviour is similar to a standard
 518                # failed cherry-pick during rebase, with a dirty index to
 519                # resolve before manually running git commit --amend then git
 520                # rebase --continue.
 521                git commit --allow-empty --allow-empty-message --amend \
 522                           --no-post-rewrite -n -q -C $sha1 &&
 523                        pick_one -n $sha1 &&
 524                        git commit --allow-empty --allow-empty-message \
 525                                   --amend --no-post-rewrite -n -q -C $sha1 \
 526                                   ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 527                                   die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 528        else
 529                pick_one $sha1 ||
 530                        die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 531        fi
 532}
 533
 534do_next () {
 535        rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
 536        read -r command sha1 rest < "$todo"
 537        case "$command" in
 538        "$comment_char"*|''|noop|drop|d)
 539                mark_action_done
 540                ;;
 541        "$cr")
 542                # Work around CR left by "read" (e.g. with Git for Windows' Bash).
 543                mark_action_done
 544                ;;
 545        pick|p)
 546                comment_for_reflog pick
 547
 548                mark_action_done
 549                do_pick $sha1 "$rest"
 550                record_in_rewritten $sha1
 551                ;;
 552        reword|r)
 553                comment_for_reflog reword
 554
 555                mark_action_done
 556                do_pick $sha1 "$rest"
 557                git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
 558                        warn "$(eval_gettext "\
 559Could not amend commit after successfully picking \$sha1... \$rest
 560This is most likely due to an empty commit message, or the pre-commit hook
 561failed. If the pre-commit hook failed, you may need to resolve the issue before
 562you are able to reword the commit.")"
 563                        exit_with_patch $sha1 1
 564                }
 565                record_in_rewritten $sha1
 566                ;;
 567        edit|e)
 568                comment_for_reflog edit
 569
 570                mark_action_done
 571                do_pick $sha1 "$rest"
 572                sha1_abbrev=$(git rev-parse --short $sha1)
 573                warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
 574                exit_with_patch $sha1 0
 575                ;;
 576        squash|s|fixup|f)
 577                case "$command" in
 578                squash|s)
 579                        squash_style=squash
 580                        ;;
 581                fixup|f)
 582                        squash_style=fixup
 583                        ;;
 584                esac
 585                comment_for_reflog $squash_style
 586
 587                test -f "$done" && has_action "$done" ||
 588                        die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
 589
 590                mark_action_done
 591                update_squash_messages $squash_style $sha1
 592                author_script_content=$(get_author_ident_from_commit HEAD)
 593                echo "$author_script_content" > "$author_script"
 594                eval "$author_script_content"
 595                if ! pick_one -n $sha1
 596                then
 597                        git rev-parse --verify HEAD >"$amend"
 598                        die_failed_squash $sha1 "$rest"
 599                fi
 600                case "$(peek_next_command)" in
 601                squash|s|fixup|f)
 602                        # This is an intermediate commit; its message will only be
 603                        # used in case of trouble.  So use the long version:
 604                        do_with_author output git commit --amend --no-verify -F "$squash_msg" \
 605                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 606                                die_failed_squash $sha1 "$rest"
 607                        ;;
 608                *)
 609                        # This is the final command of this squash/fixup group
 610                        if test -f "$fixup_msg"
 611                        then
 612                                do_with_author git commit --amend --no-verify -F "$fixup_msg" \
 613                                        ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 614                                        die_failed_squash $sha1 "$rest"
 615                        else
 616                                cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
 617                                rm -f "$GIT_DIR"/MERGE_MSG
 618                                do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
 619                                        ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 620                                        die_failed_squash $sha1 "$rest"
 621                        fi
 622                        rm -f "$squash_msg" "$fixup_msg"
 623                        ;;
 624                esac
 625                record_in_rewritten $sha1
 626                ;;
 627        x|"exec")
 628                read -r command rest < "$todo"
 629                mark_action_done
 630                eval_gettextln "Executing: \$rest"
 631                "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
 632                status=$?
 633                # Run in subshell because require_clean_work_tree can die.
 634                dirty=f
 635                (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
 636                if test "$status" -ne 0
 637                then
 638                        warn "$(eval_gettext "Execution failed: \$rest")"
 639                        test "$dirty" = f ||
 640                                warn "$(gettext "and made changes to the index and/or the working tree")"
 641
 642                        warn "$(gettext "\
 643You can fix the problem, and then run
 644
 645        git rebase --continue")"
 646                        warn
 647                        if test $status -eq 127         # command not found
 648                        then
 649                                status=1
 650                        fi
 651                        exit "$status"
 652                elif test "$dirty" = t
 653                then
 654                        # TRANSLATORS: after these lines is a command to be issued by the user
 655                        warn "$(eval_gettext "\
 656Execution succeeded: \$rest
 657but left changes to the index and/or the working tree
 658Commit or stash your changes, and then run
 659
 660        git rebase --continue")"
 661                        warn
 662                        exit 1
 663                fi
 664                ;;
 665        *)
 666                warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
 667                fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
 668                if git rev-parse --verify -q "$sha1" >/dev/null
 669                then
 670                        die_with_patch $sha1 "$fixtodo"
 671                else
 672                        die "$fixtodo"
 673                fi
 674                ;;
 675        esac
 676        test -s "$todo" && return
 677
 678        comment_for_reflog finish &&
 679        newhead=$(git rev-parse HEAD) &&
 680        case $head_name in
 681        refs/*)
 682                message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
 683                git update-ref -m "$message" $head_name $newhead $orig_head &&
 684                git symbolic-ref \
 685                  -m "$GIT_REFLOG_ACTION: returning to $head_name" \
 686                  HEAD $head_name
 687                ;;
 688        esac && {
 689                test ! -f "$state_dir"/verbose ||
 690                        git diff-tree --stat $orig_head..HEAD
 691        } &&
 692        {
 693                test -s "$rewritten_list" &&
 694                git notes copy --for-rewrite=rebase < "$rewritten_list" ||
 695                true # we don't care if this copying failed
 696        } &&
 697        hook="$(git rev-parse --git-path hooks/post-rewrite)"
 698        if test -x "$hook" && test -s "$rewritten_list"; then
 699                "$hook" rebase < "$rewritten_list"
 700                true # we don't care if this hook failed
 701        fi &&
 702                warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
 703
 704        return 1 # not failure; just to break the do_rest loop
 705}
 706
 707# can only return 0, when the infinite loop breaks
 708do_rest () {
 709        while :
 710        do
 711                do_next || break
 712        done
 713}
 714
 715# skip picking commits whose parents are unchanged
 716skip_unnecessary_picks () {
 717        fd=3
 718        while read -r command rest
 719        do
 720                # fd=3 means we skip the command
 721                case "$fd,$command" in
 722                3,pick|3,p)
 723                        # pick a commit whose parent is current $onto -> skip
 724                        sha1=${rest%% *}
 725                        case "$(git rev-parse --verify --quiet "$sha1"^)" in
 726                        "$onto"*)
 727                                onto=$sha1
 728                                ;;
 729                        *)
 730                                fd=1
 731                                ;;
 732                        esac
 733                        ;;
 734                3,"$comment_char"*|3,)
 735                        # copy comments
 736                        ;;
 737                *)
 738                        fd=1
 739                        ;;
 740                esac
 741                printf '%s\n' "$command${rest:+ }$rest" >&$fd
 742        done <"$todo" >"$todo.new" 3>>"$done" &&
 743        mv -f "$todo".new "$todo" &&
 744        case "$(peek_next_command)" in
 745        squash|s|fixup|f)
 746                record_in_rewritten "$onto"
 747                ;;
 748        esac ||
 749                die "$(gettext "Could not skip unnecessary pick commands")"
 750}
 751
 752transform_todo_ids () {
 753        while read -r command rest
 754        do
 755                case "$command" in
 756                "$comment_char"* | exec)
 757                        # Be careful for oddball commands like 'exec'
 758                        # that do not have a SHA-1 at the beginning of $rest.
 759                        ;;
 760                *)
 761                        sha1=$(git rev-parse --verify --quiet "$@" ${rest%%[     ]*}) &&
 762                        rest="$sha1 ${rest#*[    ]}"
 763                        ;;
 764                esac
 765                printf '%s\n' "$command${rest:+ }$rest"
 766        done <"$todo" >"$todo.new" &&
 767        mv -f "$todo.new" "$todo"
 768}
 769
 770expand_todo_ids() {
 771        transform_todo_ids
 772}
 773
 774collapse_todo_ids() {
 775        transform_todo_ids --short
 776}
 777
 778# Rearrange the todo list that has both "pick sha1 msg" and
 779# "pick sha1 fixup!/squash! msg" appears in it so that the latter
 780# comes immediately after the former, and change "pick" to
 781# "fixup"/"squash".
 782#
 783# Note that if the config has specified a custom instruction format
 784# each log message will be re-retrieved in order to normalize the
 785# autosquash arrangement
 786rearrange_squash () {
 787        # extract fixup!/squash! lines and resolve any referenced sha1's
 788        while read -r pick sha1 message
 789        do
 790                test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
 791                case "$message" in
 792                "squash! "*|"fixup! "*)
 793                        action="${message%%!*}"
 794                        rest=$message
 795                        prefix=
 796                        # skip all squash! or fixup! (but save for later)
 797                        while :
 798                        do
 799                                case "$rest" in
 800                                "squash! "*|"fixup! "*)
 801                                        prefix="$prefix${rest%%!*},"
 802                                        rest="${rest#*! }"
 803                                        ;;
 804                                *)
 805                                        break
 806                                        ;;
 807                                esac
 808                        done
 809                        printf '%s %s %s %s\n' "$sha1" "$action" "$prefix" "$rest"
 810                        # if it's a single word, try to resolve to a full sha1 and
 811                        # emit a second copy. This allows us to match on both message
 812                        # and on sha1 prefix
 813                        if test "${rest#* }" = "$rest"; then
 814                                fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
 815                                if test -n "$fullsha"; then
 816                                        # prefix the action to uniquely identify this line as
 817                                        # intended for full sha1 match
 818                                        echo "$sha1 +$action $prefix $fullsha"
 819                                fi
 820                        fi
 821                esac
 822        done >"$1.sq" <"$1"
 823        test -s "$1.sq" || return
 824
 825        used=
 826        while read -r pick sha1 message
 827        do
 828                case " $used" in
 829                *" $sha1 "*) continue ;;
 830                esac
 831                printf '%s\n' "$pick $sha1 $message"
 832                test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
 833                used="$used$sha1 "
 834                while read -r squash action msg_prefix msg_content
 835                do
 836                        case " $used" in
 837                        *" $squash "*) continue ;;
 838                        esac
 839                        emit=0
 840                        case "$action" in
 841                        +*)
 842                                action="${action#+}"
 843                                # full sha1 prefix test
 844                                case "$msg_content" in "$sha1"*) emit=1;; esac ;;
 845                        *)
 846                                # message prefix test
 847                                case "$message" in "$msg_content"*) emit=1;; esac ;;
 848                        esac
 849                        if test $emit = 1; then
 850                                if test -n "${format}"
 851                                then
 852                                        msg_content=$(git log -n 1 --format="${format}" ${squash})
 853                                else
 854                                        msg_content="$(echo "$msg_prefix" | sed "s/,/! /g")$msg_content"
 855                                fi
 856                                printf '%s\n' "$action $squash $msg_content"
 857                                used="$used$squash "
 858                        fi
 859                done <"$1.sq"
 860        done >"$1.rearranged" <"$1"
 861        cat "$1.rearranged" >"$1"
 862        rm -f "$1.sq" "$1.rearranged"
 863}
 864
 865# Add commands after a pick or after a squash/fixup serie
 866# in the todo list.
 867add_exec_commands () {
 868        {
 869                first=t
 870                while read -r insn rest
 871                do
 872                        case $insn in
 873                        pick)
 874                                test -n "$first" ||
 875                                printf "%s" "$cmd"
 876                                ;;
 877                        esac
 878                        printf "%s %s\n" "$insn" "$rest"
 879                        first=
 880                done
 881                printf "%s" "$cmd"
 882        } <"$1" >"$1.new" &&
 883        mv "$1.new" "$1"
 884}
 885
 886# Check if the SHA-1 passed as an argument is a
 887# correct one, if not then print $2 in "$todo".badsha
 888# $1: the SHA-1 to test
 889# $2: the line number of the input
 890# $3: the input filename
 891check_commit_sha () {
 892        badsha=0
 893        if test -z "$1"
 894        then
 895                badsha=1
 896        else
 897                sha1_verif="$(git rev-parse --verify --quiet $1^{commit})"
 898                if test -z "$sha1_verif"
 899                then
 900                        badsha=1
 901                fi
 902        fi
 903
 904        if test $badsha -ne 0
 905        then
 906                line="$(sed -n -e "${2}p" "$3")"
 907                warn "$(eval_gettext "\
 908Warning: the SHA-1 is missing or isn't a commit in the following line:
 909 - \$line")"
 910                warn
 911        fi
 912
 913        return $badsha
 914}
 915
 916# prints the bad commits and bad commands
 917# from the todolist in stdin
 918check_bad_cmd_and_sha () {
 919        retval=0
 920        lineno=0
 921        while read -r command rest
 922        do
 923                lineno=$(( $lineno + 1 ))
 924                case $command in
 925                "$comment_char"*|''|noop|x|exec)
 926                        # Doesn't expect a SHA-1
 927                        ;;
 928                "$cr")
 929                        # Work around CR left by "read" (e.g. with Git for
 930                        # Windows' Bash).
 931                        ;;
 932                pick|p|drop|d|reword|r|edit|e|squash|s|fixup|f)
 933                        if ! check_commit_sha "${rest%%[        ]*}" "$lineno" "$1"
 934                        then
 935                                retval=1
 936                        fi
 937                        ;;
 938                *)
 939                        line="$(sed -n -e "${lineno}p" "$1")"
 940                        warn "$(eval_gettext "\
 941Warning: the command isn't recognized in the following line:
 942 - \$line")"
 943                        warn
 944                        retval=1
 945                        ;;
 946                esac
 947        done <"$1"
 948        return $retval
 949}
 950
 951# Print the list of the SHA-1 of the commits
 952# from stdin to stdout
 953todo_list_to_sha_list () {
 954        git stripspace --strip-comments |
 955        while read -r command sha1 rest
 956        do
 957                case $command in
 958                "$comment_char"*|''|noop|x|"exec")
 959                        ;;
 960                *)
 961                        long_sha=$(git rev-list --no-walk "$sha1" 2>/dev/null)
 962                        printf "%s\n" "$long_sha"
 963                        ;;
 964                esac
 965        done
 966}
 967
 968# Use warn for each line in stdin
 969warn_lines () {
 970        while read -r line
 971        do
 972                warn " - $line"
 973        done
 974}
 975
 976# Switch to the branch in $into and notify it in the reflog
 977checkout_onto () {
 978        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
 979        output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
 980        git update-ref ORIG_HEAD $orig_head
 981}
 982
 983get_missing_commit_check_level () {
 984        check_level=$(git config --get rebase.missingCommitsCheck)
 985        check_level=${check_level:-ignore}
 986        # Don't be case sensitive
 987        printf '%s' "$check_level" | tr 'A-Z' 'a-z'
 988}
 989
 990# Check if the user dropped some commits by mistake
 991# Behaviour determined by rebase.missingCommitsCheck.
 992# Check if there is an unrecognized command or a
 993# bad SHA-1 in a command.
 994check_todo_list () {
 995        raise_error=f
 996
 997        check_level=$(get_missing_commit_check_level)
 998
 999        case "$check_level" in
1000        warn|error)
1001                # Get the SHA-1 of the commits
1002                todo_list_to_sha_list <"$todo".backup >"$todo".oldsha1
1003                todo_list_to_sha_list <"$todo" >"$todo".newsha1
1004
1005                # Sort the SHA-1 and compare them
1006                sort -u "$todo".oldsha1 >"$todo".oldsha1+
1007                mv "$todo".oldsha1+ "$todo".oldsha1
1008                sort -u "$todo".newsha1 >"$todo".newsha1+
1009                mv "$todo".newsha1+ "$todo".newsha1
1010                comm -2 -3 "$todo".oldsha1 "$todo".newsha1 >"$todo".miss
1011
1012                # Warn about missing commits
1013                if test -s "$todo".miss
1014                then
1015                        test "$check_level" = error && raise_error=t
1016
1017                        warn "$(gettext "\
1018Warning: some commits may have been dropped accidentally.
1019Dropped commits (newer to older):")"
1020
1021                        # Make the list user-friendly and display
1022                        opt="--no-walk=sorted --format=oneline --abbrev-commit --stdin"
1023                        git rev-list $opt <"$todo".miss | warn_lines
1024
1025                        warn "$(gettext "\
1026To avoid this message, use \"drop\" to explicitly remove a commit.
1027
1028Use 'git config rebase.missingCommitsCheck' to change the level of warnings.
1029The possible behaviours are: ignore, warn, error.")"
1030                        warn
1031                fi
1032                ;;
1033        ignore)
1034                ;;
1035        *)
1036                warn "$(eval_gettext "Unrecognized setting \$check_level for option rebase.missingCommitsCheck. Ignoring.")"
1037                ;;
1038        esac
1039
1040        if ! check_bad_cmd_and_sha "$todo"
1041        then
1042                raise_error=t
1043        fi
1044
1045        if test $raise_error = t
1046        then
1047                # Checkout before the first commit of the
1048                # rebase: this way git rebase --continue
1049                # will work correctly as it expects HEAD to be
1050                # placed before the commit of the next action
1051                checkout_onto
1052
1053                warn "$(gettext "You can fix this with 'git rebase --edit-todo' and then run 'git rebase --continue'.")"
1054                die "$(gettext "Or you can abort the rebase with 'git rebase --abort'.")"
1055        fi
1056}
1057
1058# The whole contents of this file is run by dot-sourcing it from
1059# inside a shell function.  It used to be that "return"s we see
1060# below were not inside any function, and expected to return
1061# to the function that dot-sourced us.
1062#
1063# However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
1064# construct and continue to run the statements that follow such a "return".
1065# As a work-around, we introduce an extra layer of a function
1066# here, and immediately call it after defining it.
1067git_rebase__interactive () {
1068
1069case "$action" in
1070continue)
1071        # do we have anything to commit?
1072        if git diff-index --cached --quiet HEAD --
1073        then
1074                # Nothing to commit -- skip this commit
1075
1076                test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
1077                rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
1078                die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
1079        else
1080                if ! test -f "$author_script"
1081                then
1082                        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
1083                        die "$(eval_gettext "\
1084You have staged changes in your working tree.
1085If these changes are meant to be
1086squashed into the previous commit, run:
1087
1088  git commit --amend \$gpg_sign_opt_quoted
1089
1090If they are meant to go into a new commit, run:
1091
1092  git commit \$gpg_sign_opt_quoted
1093
1094In both cases, once you're done, continue with:
1095
1096  git rebase --continue
1097")"
1098                fi
1099                . "$author_script" ||
1100                        die "$(gettext "Error trying to find the author identity to amend commit")"
1101                if test -f "$amend"
1102                then
1103                        current_head=$(git rev-parse --verify HEAD)
1104                        test "$current_head" = $(cat "$amend") ||
1105                        die "$(gettext "\
1106You have uncommitted changes in your working tree. Please commit them
1107first and then run 'git rebase --continue' again.")"
1108                        do_with_author git commit --amend --no-verify -F "$msg" -e \
1109                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1110                                die "$(gettext "Could not commit staged changes.")"
1111                else
1112                        do_with_author git commit --no-verify -F "$msg" -e \
1113                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1114                                die "$(gettext "Could not commit staged changes.")"
1115                fi
1116        fi
1117
1118        if test -r "$state_dir"/stopped-sha
1119        then
1120                record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
1121        fi
1122
1123        require_clean_work_tree "rebase"
1124        do_rest
1125        return 0
1126        ;;
1127skip)
1128        git rerere clear
1129
1130        do_rest
1131        return 0
1132        ;;
1133edit-todo)
1134        git stripspace --strip-comments <"$todo" >"$todo".new
1135        mv -f "$todo".new "$todo"
1136        collapse_todo_ids
1137        append_todo_help
1138        gettext "
1139You are editing the todo file of an ongoing interactive rebase.
1140To continue rebase after editing, run:
1141    git rebase --continue
1142
1143" | git stripspace --comment-lines >>"$todo"
1144
1145        git_sequence_editor "$todo" ||
1146                die "$(gettext "Could not execute editor")"
1147        expand_todo_ids
1148
1149        exit
1150        ;;
1151esac
1152
1153comment_for_reflog start
1154
1155if test ! -z "$switch_to"
1156then
1157        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
1158        output git checkout "$switch_to" -- ||
1159                die "$(eval_gettext "Could not checkout \$switch_to")"
1160
1161        comment_for_reflog start
1162fi
1163
1164orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
1165mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
1166
1167: > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
1168write_basic_state
1169if test t = "$preserve_merges"
1170then
1171        if test -z "$rebase_root"
1172        then
1173                mkdir "$rewritten" &&
1174                for c in $(git merge-base --all $orig_head $upstream)
1175                do
1176                        echo $onto > "$rewritten"/$c ||
1177                                die "$(gettext "Could not init rewritten commits")"
1178                done
1179        else
1180                mkdir "$rewritten" &&
1181                echo $onto > "$rewritten"/root ||
1182                        die "$(gettext "Could not init rewritten commits")"
1183        fi
1184        # No cherry-pick because our first pass is to determine
1185        # parents to rewrite and skipping dropped commits would
1186        # prematurely end our probe
1187        merges_option=
1188else
1189        merges_option="--no-merges --cherry-pick"
1190fi
1191
1192shorthead=$(git rev-parse --short $orig_head)
1193shortonto=$(git rev-parse --short $onto)
1194if test -z "$rebase_root"
1195        # this is now equivalent to ! -z "$upstream"
1196then
1197        shortupstream=$(git rev-parse --short $upstream)
1198        revisions=$upstream...$orig_head
1199        shortrevisions=$shortupstream..$shorthead
1200else
1201        revisions=$onto...$orig_head
1202        shortrevisions=$shorthead
1203fi
1204format=$(git config --get rebase.instructionFormat)
1205# the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
1206git rev-list $merges_option --format="%m%H ${format:-%s}" \
1207        --reverse --left-right --topo-order \
1208        $revisions ${restrict_revision+^$restrict_revision} | \
1209        sed -n "s/^>//p" |
1210while read -r sha1 rest
1211do
1212
1213        if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1214        then
1215                comment_out="$comment_char "
1216        else
1217                comment_out=
1218        fi
1219
1220        if test t != "$preserve_merges"
1221        then
1222                printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1223        else
1224                if test -z "$rebase_root"
1225                then
1226                        preserve=t
1227                        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1228                        do
1229                                if test -f "$rewritten"/$p
1230                                then
1231                                        preserve=f
1232                                fi
1233                        done
1234                else
1235                        preserve=f
1236                fi
1237                if test f = "$preserve"
1238                then
1239                        touch "$rewritten"/$sha1
1240                        printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1241                fi
1242        fi
1243done
1244
1245# Watch for commits that been dropped by --cherry-pick
1246if test t = "$preserve_merges"
1247then
1248        mkdir "$dropped"
1249        # Save all non-cherry-picked changes
1250        git rev-list $revisions --left-right --cherry-pick | \
1251                sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1252        # Now all commits and note which ones are missing in
1253        # not-cherry-picks and hence being dropped
1254        git rev-list $revisions |
1255        while read rev
1256        do
1257                if test -f "$rewritten"/$rev &&
1258                   ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1259                then
1260                        # Use -f2 because if rev-list is telling us this commit is
1261                        # not worthwhile, we don't want to track its multiple heads,
1262                        # just the history of its first-parent for others that will
1263                        # be rebasing on top of it
1264                        git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1265                        sha1=$(git rev-list -1 $rev)
1266                        sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1267                        rm "$rewritten"/$rev
1268                fi
1269        done
1270fi
1271
1272test -s "$todo" || echo noop >> "$todo"
1273test -n "$autosquash" && rearrange_squash "$todo"
1274test -n "$cmd" && add_exec_commands "$todo"
1275
1276todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
1277todocount=${todocount##* }
1278
1279cat >>"$todo" <<EOF
1280
1281$comment_char $(eval_ngettext \
1282        "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
1283        "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
1284        "$todocount")
1285EOF
1286append_todo_help
1287gettext "
1288However, if you remove everything, the rebase will be aborted.
1289
1290" | git stripspace --comment-lines >>"$todo"
1291
1292if test -z "$keep_empty"
1293then
1294        printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
1295fi
1296
1297
1298has_action "$todo" ||
1299        return 2
1300
1301cp "$todo" "$todo".backup
1302collapse_todo_ids
1303git_sequence_editor "$todo" ||
1304        die_abort "$(gettext "Could not execute editor")"
1305
1306has_action "$todo" ||
1307        return 2
1308
1309check_todo_list
1310
1311expand_todo_ids
1312
1313test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
1314
1315checkout_onto
1316do_rest
1317
1318}
1319# ... and then we call the whole thing.
1320git_rebase__interactive